/*
JMP Clinical Analytical Process

Name: AddStudyLocal
Author: Li Li, SAS Institute Inc.
Support: Li Li, SAS Institute Inc.
History:
   sasrdw 02Nov10 initial coding
   rizink Sep2011 Added Metadata functionality from SAS CST
Description: 
This process defines the default settings
for JMP Clinical. 
*/

/*
-----------------------------------------------------------
Copyright (C) 2008 SAS Institute, Inc. All rights reserved. 

Notice: 
The above copyright notice and this notice must appear in
any whole or partial copy of this code and any related
documentation. Permission to use, copy, and modify the
source code contained in this file is hereby granted, but
is limited to customers of SAS with a valid license for the
SAS software product with which this file was provided. 
Except as expressly set forth herein, the terms of such
license apply.
-----------------------------------------------------------
*/

*ProcessVariables;


%let StudyName=%nrbquote(Nicardipine Early Snapshot);
%let InPath=%nrbquote($JMP_HOME\LifeSciences\Sample Data\NicardipineAbbr\SDTM\);
%let AInPath=%nrbquote();
%let TransportCheck= No;
%let SnpComp= Yes;
%let ShowResultFlag= Yes;
%let OutPath=%nrbquote();
%let ServerOutPath= ;
%let MacroPath= $JMP_HOME\LifeSciences\MacroLib;
%let Server= Local;
%let LS_HOME=%nrbquote($JMP_HOME\LifeSciences\);
%let CLINICAL_HOME=%nrbquote($JMP_HOME\Clinical\);
%let USER_HOME=%nrbquote(%jg_getPath(/user/clinical));
%let LSUSER_HOME=%nrbquote(%jg_getPath(/user/lifesciences));
%let Starter_Index=%nrbquote(3);
%let LS_Product=%nrbquote(Clinical);
%let CLIENT_HOST= Windows;


*ProcessBody;
%macro runAP;  
filename customap "%jg_getPath(/user/clinical/processlibrary, AddStudyLocal.sas)";
%if %sysfunc(fexist(customap)) %then %do;
   %include customap;
%end;
%else %do;
   %include "C:\Program Files\SAShome\JMP\10\Clinical\ProcessLibrary/AddStudyLocal.sas";
%end;
%mend;
%runAP;
      