*************************************************************************************;
*************************************************************************************;
*************************************************************************************;

%macro FINDINIT(code = A);   
   %if &code = A %then %let domain = &FFDomAU;
   %else %if &code = B %then %let domain = &FFDomBU;
   %else %if &code = C %then %let domain = &FFDomCU;

   %if %upcase(&&FFl&code) = YES and %upcase(&&FBase&code) = NO and %scan(%upcase(&&FType&code), 1, " ") = NEITHER %then %do;
      %put [MS_S_0186];
      %put ERROR: At least one &domain analysis should be selected for inclusion into the narrative.;
      %let exiterror = 1;
      %goto exit;
   %end;

   %if %sysfunc(findw(%upcase( &&&domain.VARS), ABLFL)) %then %let FBlFlag&code = ABLFL;
   %else %if %sysfunc(findw(%upcase( &&&domain.VARS), &domain.BLFL)) %then %let FBlFlag&code = &domain.BLFL;
   %else %let FBlFlag&code = ;

   %if %scan(%upcase(&&FCode&code), 2, " ") = NAME %then %let FVar&code = &domain.TEST;
   %else %let FVar&code = &domain.TESTCD;

   %if %scan(%upcase(&&StOr&code), 1, " ") = ORIGINAL %then %do;   
      %if &domain ne LB %then %do;
         %if not (%sysfunc(findw(%upcase( &&&domain.VARS), USUBJID)) and
                  %sysfunc(findw(%upcase( &&&domain.VARS), &domain.DTC)) and
                  %sysfunc(findw(%upcase( &&&domain.VARS), &&FVar&code)) and
                  %sysfunc(findw(%upcase( &&&domain.VARS), &domain.ORRES))
                  ) %then %let FFl&code = No; 
      %end;
      %else %do;
         %if not (%sysfunc(findw(%upcase( &&&domain.VARS), USUBJID)) and
                  %sysfunc(findw(%upcase( &&&domain.VARS), &domain.DTC)) and
                  %sysfunc(findw(%upcase( &&&domain.VARS), &&FVar&code)) and
                  %sysfunc(findw(%upcase( &&&domain.VARS), &domain.ORRES)) and
                  %sysfunc(findw(%upcase( &&&domain.VARS), &domain.ORNRLO)) and
                  %sysfunc(findw(%upcase( &&&domain.VARS), &domain.ORNRHI)) and
                  %sysfunc(findw(%upcase( &&&domain.VARS), &domain.NRIND)) 
                  ) %then %let FFl&code = No;
         %if ^%sysfunc(findw(%upcase( &&&domain.VARS), &domain.NRIND)) %then %do;
            %put ERROR: The variable LBNRIND is required for the LB domain and is not available for the current study. Please deselect the LB domain;
            %let exiterror = 1;
            %goto exit;         
         %end;
      %end;   
   %end;
   %else %do;
      %if &domain ne LB %then %do;
         %if not (%sysfunc(findw(%upcase( &&&domain.VARS), USUBJID)) and
                  %sysfunc(findw(%upcase( &&&domain.VARS), &domain.DTC)) and
                  %sysfunc(findw(%upcase( &&&domain.VARS), &&FVar&code)) and
                  (%sysfunc(findw(%upcase( &&&domain.VARS), &domain.STRESC)) or %sysfunc(findw(%upcase( &&&domain.VARS), &domain.STRESN)))
                  ) %then %let FFl&code = No; 
      %end;
      %else %do;
         %if not (%sysfunc(findw(%upcase( &&&domain.VARS), USUBJID)) and
                  %sysfunc(findw(%upcase( &&&domain.VARS), &domain.DTC)) and
                  %sysfunc(findw(%upcase( &&&domain.VARS), &&FVar&code)) and
                  %sysfunc(findw(%upcase( &&&domain.VARS), &domain.STRESN)) and
                  %sysfunc(findw(%upcase( &&&domain.VARS), &domain.STNRLO)) and
                  %sysfunc(findw(%upcase( &&&domain.VARS), &domain.STNRHI)) and
                  %sysfunc(findw(%upcase( &&&domain.VARS), &domain.NRIND)) 
                  ) %then %let FFl&code = No;
         %if ^%sysfunc(findw(%upcase( &&&domain.VARS), &domain.NRIND)) %then %do;
            %put ERROR: The variable LBNRIND is required for the LB domain and is not available for the current study. Please deselect the LB domain;
            %let exiterror = 1;
            %goto exit;         
         %end;                  
      %end;      
   %end;
   %exit:;
%mend FINDINIT;

*************************************************************************************;
*************************************************************************************;
*************************************************************************************;

%macro FINDING(code = A);  
   %if &code = A %then %let domain = &FFDomAU;
   %else %if &code = B %then %let domain = &FFDomBU;
   %else %if &code = C %then %let domain = &FFDomCU;
   
   %if &domain = LB %then %do;
      %let _tid_ = %sysfunc(open(dom&code));
         %let tnum = %sysfunc(varnum(&_tid_,LBNRIND));
         %let curlen = %sysfunc(varlen(&_tid_,&tnum));
         %if %sysevalf(&curlen<6) %then %let curlen = 6; 
      %let _tid_ = %sysfunc(close(&_tid_));

      data dom&code;
         length lbnrind $ &curlen;
         set dom&code;
         if upcase(lbnrind) in ("H", "HI") then &domain.nrind = "%upcase(&trHigh)";
         else if upcase(lbnrind) in ("L", "LO") then &domain.nrind = "%upcase(&trLow)";
         else if upcase(lbnrind) in ("N", "NORM") then &domain.nrind = "%upcase(&trNormal)";                
      run;
   %end;

   data dom&code;
      merge aesubs(in = ina) dom&code(in = inb);
      by usubjid;
      if ina and inb;
      %calculateStudyDays(&domain);
      %DATE9(var=&domain.dtc,return=&domain.dt);
      drop &domain.dy errdt:;
      %if &domain ne LB %then %do;
         if d9partial_&domain.DTC then &&FVar&code = cats(&&FVar&code,"*");
      %end;
      %TIME5(var=&domain.dtc,return=&domain.ti); 
   run;
       
   %TREATMENTEMERGENT(dataset = dom&code, domain = &domain, date = &domain.DTC);
 
   proc sort data = dom&code out = dom&code(drop = &domain.dtc _OTFLAG _OTFUFLAG);
      by usubjid &&FVar&code &&FBlFlag&code stdy &domain.ti;
   run;

   data bdom&code osdom&code;
      set dom&code;
      %if %length(&&FBlFlag&code) %then %do;
         if index(upcase(&&FBlFlag&code),"Y") then output bdom&code;
      %end;
      %else %do;
         if _TRTEMRG = 0 then output bdom&code;
      %end;
      if _TRTEMRG = 1 then output osdom&code;
   run;
   
   *** Take the last record for LB and the last day for others ***;
   %if &domain = LB %then %do;
      data bdom&code;
         set bdom&code;
         by usubjid &&FVar&code;
         if last.&&FVar&code;
         base = 1;
      run;
   %end;
   %else %do;
      data bdt&code;
         set bdom&code;
         by usubjid &&FVar&code;
         if last.&&FVar&code;
         keep usubjid &&FVar&code &domain.dt;
      run;
      
      proc sort data = bdom&code;
         by usubjid &&FVar&code &domain.dt;
      run;

   
      data bdom&code;
         merge bdt&code(in = ina) bdom&code;
         by usubjid &&FVar&code &domain.dt;
         if ina;
         base = 1;
      run;
   
      proc datasets nolist;
         delete bdt&code;
      quit;
   %end;

   data dom&code(drop = &&FBlFlag&code);
      set bdom&code(in=ina) osdom&code;
      if missing(base) then base = 0;
   run;
   
   *** get unique lab dates to know if anything happened on the date just prior or post (if no abnormalities occurred) ***;
   %if &domain = LB %then %do;
      proc sql;
         create table dates&code as
         select distinct usubjid, &domain.dt from osdom&code order by usubjid, &domain.dt;
      quit;
   %end;

   proc datasets nolist;
      delete osdom&code;
   quit;

   %if &domain = LB %then %do;
      proc sort data = dom&code;
         by usubjid &&FVar&code descending base stdy &domain.ti;
      run;
   %end;
   %else %do;
      proc sort data = dom&code;
         by usubjid &&FVar&code base stdy &domain.ti;
      run;  
   %end;
    
   %if &domain = LB %then %do;
      data dom&code;
         length b&domain.nrind $ &curlen;
         set dom&code;
         by usubjid &&FVar&code descending base stdy;
         retain b&domain.nrind;
         if first.&&FVar&code and base = 0 then b&domain.nrind = "";       
         else if first.&&FVar&code and base = 1 then b&domain.nrind = &domain.nrind;
      run;
            
      data dom&code;
         set dom&code;
         if d9partial_&domain.DTC then &&FVar&code = cats(&&FVar&code,"*");
      run;

      data dom&code(keep = usubjid &domain.dt stdy &&FVar&code &domain.term base);
         length &domain.term $ 1000;
         set dom&code;
         %if %upcase(&&FRange&code) = ABNORMAL %then %do;
            if upcase(b&domain.nrind) = "%upcase(&trNormal)" and upcase(&domain.nrind) ne "%upcase(&trNormal)";
         %end; 
         %else %if %upcase(&&FRange&code) = DIFFERENT %then %do;
            if upcase(b&domain.nrind) ne upcase(&domain.nrind);
         %end;
         %else %if %upcase(&&FRange&code) = ALL %then %do;
            if upcase(&domain.nrind) ne "%upcase(&trNormal)";
         %end;

         %if &&FVar&code = &domain.TEST %then %let valuecode = %str(lowcase(&&FVar&code));
         %else %if &&FVar&code = &domain.TESTCD %then %let valuecode = %str(upcase(&&FVar&code));

         %if %scan(%upcase(&&StOr&code), 1, " ") = ORIGINAL %then %do;                                    
             %if ^%sysfunc(findw(%upcase( &&&domain.VARS), &domain.ORRESU)) %then %do;
               &domain.ORRESU = "";             
             %end;
             ORRESN = input(&domain.ORRES, ?? best32.);
             ORNRLON = input(&domain.ORNRLO, ?? best32.);
             ORNRHIN = input(&domain.ORNRHI, ?? best32.);
             %if %upcase(&&FRound&code) = YES %then %do;
               if lengthn(scan(ORRESN,2,".")) > &&FDec&code then ORRESN = round(ORRESN, 0.1**&&FDec&code);
               if lengthn(scan(ORNRLON,2,".")) > &&FDec&code then ORNRLON = round(ORNRLON, 0.1**&&FDec&code);
               if lengthn(scan(ORNRHIN,2,".")) > &&FDec&code then ORNRHIN = round(ORNRHIN, 0.1**&&FDec&code);
             %end;
             
            if ORRESN > . and ORNRLON > . and ORNRHIN > . then 
                  &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",ORRESN), cats(&domain.ORRESU,","), 
                  "%sysfunc(lowcase(&trRange)) =", cats("(",ORNRLON), "-", cats(ORNRHIN,")"));    
            else if ORRESN > . and ORNRLON = . and ORNRHIN > . then 
                  &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",ORRESN), cats(&domain.ORRESU,","), 
                  "%sysfunc(lowcase(&trRange)) =", "(&trNA", "-", cats(ORNRHIN,")"));    
            else if ORRESN > . and ORNRLON > . and ORNRHIN = . then 
                  &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",ORRESN), cats(&domain.ORRESU,","), 
                  "%sysfunc(lowcase(&trRange)) =", cats("(",ORNRLON), "-", "&trNA)");    
            else if ORRESN > . and ORNRLON = . and ORNRHIN = . then 
                  &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",ORRESN), cats(&domain.ORRESU,","));
            else if ORRESN = . and &domain.ORRES ne "" then
                  &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",lowcase(&domain.ORRES)), &domain.ORRESU);
         %end;
         %else %do;
             %if ^%sysfunc(findw(%upcase( &&&domain.VARS), &domain.STRESU)) %then %do;
               &domain.STRESU = "";             
             %end;
             %if ^%sysfunc(findw(%upcase( &&&domain.VARS), &domain.STNRC)) %then %do;
               &domain.STNRC = "";             
             %end;

             %if %upcase(&&FRound&code) = YES %then %do;
               if lengthn(scan(&domain.STRESN,2,".")) > &&FDec&code then &domain.STRESN = round(&domain.STRESN, 0.1**&&FDec&code);
               if lengthn(scan(&domain.STNRLO,2,".")) > &&FDec&code then &domain.STNRLO = round(&domain.STNRLO, 0.1**&&FDec&code);
               if lengthn(scan(&domain.STNRHI,2,".")) > &&FDec&code then &domain.STNRHI = round(&domain.STNRHI, 0.1**&&FDec&code);
             %end;
             
            if &domain.STRESN > . and &domain.STNRLO > . and &domain.STNRHI > . then 
                  &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",&domain.STRESN), cats(&domain.STRESU,","), 
                  "%sysfunc(lowcase(&trRange)) =", cats("(",&domain.STNRLO), "-", cats(&domain.STNRHI,")"));    
            else if &domain.STRESN > . and &domain.STNRLO = . and &domain.STNRHI > . then 
                  &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",&domain.STRESN), cats(&domain.STRESU,","), 
                  %sysfunc(lowcase(&trRange)), "=", "(&trNA", "-", cats(&domain.STNRHI,")"));    
            else if &domain.STRESN > . and &domain.STNRLO > . and &domain.STNRHI = . then 
                  &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",&domain.STRESN), cats(&domain.STRESU,","), 
                  "%sysfunc(lowcase(&trRange)) =", cats("(",&domain.STNRLO), "-", "&trNA)");    
            else if &domain.STRESN > . and &domain.STNRLO = . and &domain.STNRHI = . then 
                  &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",&domain.STRESN), cats(&domain.STRESU,","));
            %if %sysfunc(findw(%upcase( &&&domain.VARS), &domain.STRESC)) %then %do;                  
               else if &domain.STRESN = . and &domain.STRESC ne "" and &domain.STNRC = "" then
                     &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",lowcase(&domain.STRESC)), &domain.STRESU);
               else if &domain.STRESN = . and &domain.STRESC ne "" and &domain.STNRC ne "" then
                     &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",lowcase(&domain.STRESC)), cats(&domain.STRESU,","),
                     "%sysfunc(lowcase(&trRange)) =",&domain.STNRC);
            %end;
         %end;
     
         %if %upcase(&&FRange&code) = DIFFERENT %then %do;
            if b&domain.nrind ne "" then &domain.term = cats(&domain.term, ", &trBL = ",cats(lowcase(b&domain.nrind),"]"));
            else &domain.term = cats(&domain.term, ", &trBL = %sysfunc(lowcase(&trMissing))]");
         %end;
         %else %do;
            &domain.term = cats(&domain.term,"]");
         %end;
      run;              
      %SHRINKCHARS(dsn = dom&code, vars = &domain.term);    
   %end;
   %else %do;  
      proc freq noprint data = dom&code;
         tables usubjid * &&FVar&code * base * stdy / out = multcnt&code(keep = usubjid &&FVar&code base stdy count rename = (count = multcnt&domain));
      run;
      
      data dom&code;
         set dom&code;
         %if %scan(%upcase(&&StOr&code), 1, " ") = ORIGINAL %then %do;                                    
            %if ^%sysfunc(findw(%upcase( &&&domain.VARS), &domain.ORRESU)) %then %do;
               &domain.ORRESU = "";             
            %end;
            ORRESN = input(&domain.ORRES, ?? best32.);;
         %end;
         %else %do;
            %if ^%sysfunc(findw(%upcase( &&&domain.VARS), &domain.STRESU)) %then %do;
               &domain.STRESU = "";            
            %end;
            %if ^%sysfunc(findw(%upcase( &&&domain.VARS), &domain.STRESC)) %then %do;
               &domain.STRESC = "";
            %end;
            %if ^%sysfunc(findw(%upcase( &&&domain.VARS), &domain.STRESN)) %then %do;
               &domain.STRESN = .;
            %end;            
         %end;
      run;
            
      data dom&code;
         length val&domain timelist $ 2000;
         merge dom&code multcnt&code;
         by usubjid &&FVar&code base stdy;
         retain cnt val&domain timelist;
         if first.stdy then do;
            cnt = 1;            
            %if %scan(%upcase(&&StOr&code), 1, " ") = ORIGINAL %then %do;
               %if %upcase(&&FRound&code) = YES %then %do;            
                  if ORRESN > . and lengthn(scan(ORRESN,2,".")) > &&FDec&code then val&domain = strip(put(ORRESN, 8.&&FDec&code));
                  else if ORRESN > . then val&domain = strip(put(ORRESN, best32.));
                  else if ORRESN = . then val&domain = lowcase(&domain.ORRES);
               %end;
               %else %do;
                  val&domain = lowcase(&domain.ORRES);
               %end;
            %end;
            %else %do;
               %if %upcase(&&FRound&code) = YES %then %do;            
                  if &domain.STRESN > . and lengthn(scan(&domain.STRESN,2,".")) > &&FDec&code then val&domain = strip(put(&domain.STRESN, 8.&&FDec&code));
                  else if &domain.STRESN > . then val&domain = strip(put(&domain.STRESN, best32.));
                  else if &domain.STRESN = . then val&domain = lowcase(&domain.STRESC);
               %end;
               %else %do;
                  if &domain.STRESN > . then val&domain = strip(put(&domain.STRESN, best32.));
                  else if &domain.STRESN = . then val&domain = lowcase(&domain.STRESC);
               %end;
            %end;                        
            if &domain.ti > . then timelist = put(&domain.ti, time5.);
            else timelist = "%sysfunc(lowcase(&trUnknown))";
         end;
         else do;
            cnt = cnt + 1;
            %if %scan(%upcase(&&StOr&code), 1, " ") = ORIGINAL %then %do;
               if cnt < multcnt&domain then do;
                  %if %upcase(&&FRound&code) = YES %then %do; 
                     if ORRESN > . and lengthn(scan(ORRESN,2,".")) > &&FDec&code then val&domain = catx(", ", val&domain, strip(put(ORRESN, 8.&&FDec&code)));
                     else if ORRESN > . then val&domain = catx(", ", val&domain, strip(put(ORRESN, best32.)));
                     else if ORRESN = . then val&domain = catx(", ", val&domain, lowcase(&domain.ORRES));
                  %end;
                  %else %do;
                     val&domain = catx(", ", val&domain, lowcase(&domain.ORRES));
                  %end;
               end;
               else if cnt = multcnt&domain then do;
                  %if %upcase(&&FRound&code) = YES %then %do; 
                     if ORRESN > . and lengthn(scan(ORRESN,2,".")) > &&FDec&code then val&domain = catx(" ", val&domain, "&trAndText", strip(put(ORRESN, 8.&&FDec&code)));
                     else if ORRESN > . then val&domain = catx(" ", val&domain, "&trAndText", strip(put(ORRESN, best32.)));
                     else if ORRESN = . then val&domain = catx(" ", val&domain, "&trAndText", lowcase(&domain.ORRES));                              
                  %end;
                  %else %do;
                     val&domain = catx(" ", val&domain, "&trAndText", lowcase(&domain.ORRES)); 
                  %end;
               end;            
            %end;
            %else %do;
               if cnt < multcnt&domain then do;
                  %if %upcase(&&FRound&code) = YES %then %do; 
                     if &domain.STRESN > . and lengthn(scan(&domain.STRESN,2,".")) > &&FDec&code then val&domain = catx(", ", val&domain, strip(put(&domain.STRESN, 8.&&FDec&code)));
                     else if &domain.STRESN > . then val&domain = catx(", ", val&domain, strip(put(&domain.STRESN, best32.)));
                     else if &domain.STRESN = . then val&domain = catx(", ", val&domain, lowcase(&domain.STRESC));
                  %end;
                  %else %do;
                     if &domain.STRESN > . then val&domain = catx(", ", val&domain, strip(put(&domain.STRESN, best32.)));
                     else if &domain.STRESN = . then val&domain = catx(", ", val&domain, lowcase(&domain.STRESC));
                  %end;
               end;
               else if cnt = multcnt&domain then do;
                  %if %upcase(&&FRound&code) = YES %then %do; 
                     if &domain.STRESN > . and lengthn(scan(&domain.STRESN,2,".")) > &&FDec&code then val&domain = catx(" ", val&domain,"&trAndText",strip(put(&domain.STRESN, 8.&&FDec&code)));
                     else if &domain.STRESN > . then val&domain = catx(" ", val&domain, "&trAndText",strip(put(&domain.STRESN, best32.)));
                     else if &domain.STRESN = . then val&domain = catx(" ", val&domain, "&trAndText",lowcase(&domain.STRESC));
                  %end;
                  %else %do;
                     if &domain.STRESN > . then val&domain = catx(" ", val&domain, "&trAndText",strip(put(&domain.STRESN, best32.)));
                     else if &domain.STRESN = . then val&domain = catx(" ", val&domain, "&trAndText",lowcase(&domain.STRESC));                  
                  %end;
               end;            
            %end;
            if cnt < multcnt&domain and &domain.ti > . then timelist = catx(", ", timelist, put(&domain.ti, time5.));
            else if cnt < multcnt&domain and &domain.ti = . then timelist = catx(", ", timelist, "%sysfunc(lowcase(&trUnknown))");
            else if cnt = multcnt&domain and &domain.ti > . then timelist = catx(" ", timelist, "&trAndText", cats(put(&domain.ti, time5.), ", &trRespectively"));
            else if cnt = multcnt&domain and &domain.ti = . then timelist = catx(" ", timelist, "&trAndText", cats("%sysfunc(lowcase(&trUnknown))", ", &trRespectively"));
         end;
         if last.stdy;
      run;      
      
      %SHRINKCHARS(dsn = dom&code, vars = val&domain timelist);   
     
      data dom&code(keep = usubjid &domain.dt &&FVar&code &domain.term base stdy);
         length &domain.term $ 5000;
         set dom&code;      

         %if &&FVar&code = &domain.TEST %then %let valuecode = %str(lowcase(&&FVar&code));
         %else %if &&FVar&code = &domain.TESTCD %then %let valuecode = %str(upcase(&&FVar&code));

         if multcnt&domain = 1 then do;
            %if %scan(%upcase(&&StOr&code), 1, " ") = ORIGINAL %then %do;           
               if &domain.ORRESU ne "" then &domain.term = catx(" ", &valuecode, cats("(",val&domain), cats(&domain.ORRESU,")"));
               else &domain.term = catx(" ", &valuecode, cats("(",val&domain,")"));
            %end;
            %else %do;
               if &domain.STRESU ne "" then &domain.term = catx(" ", &valuecode, cats("(",val&domain), cats(&domain.STRESU,")"));
               else &domain.term = catx(" ", &valuecode, cats("(",val&domain,")"));
            %end;
         end;
         else if multcnt&domain > 1 then do;
            %if %scan(%upcase(&&StOr&code), 1, " ") = ORIGINAL %then %do;           
               if &domain.ORRESU ne "" then &domain.term = catx(" ", &valuecode, cats("(",val&domain), catx(" ", &domain.ORRESU, "&trAtText", cats(timelist,")")));
               else &domain.term = catx(" ", &valuecode, cats("(",catx(" ",val&domain, "&trAtText", cats(timelist,")"))));
            %end;
            %else %do;
               if &domain.STRESU ne "" then &domain.term = catx(" ", &valuecode, cats("(",val&domain), catx(" ", &domain.STRESU, "&trAtText", cats(timelist,")")));
               else &domain.term = catx(" ", &valuecode, cats("(",catx(" ",val&domain, "&trAtText", cats(timelist,")"))));
            %end;
         end;        
      run;
      %SHRINKCHARS(dsn = dom&code, vars = &domain.term); 

      proc datasets nolist;
         delete multcnt&domain;
      quit;
   %end;
   
   %if &domain = LB %then %do;          
      proc sort data = dom&code;
        by usubjid &domain.dt &&FVar&code;
      run;

      data dom&code;
         merge dates&code dom&code;
         by usubjid &domain.dt;
      run;
   %end;

   proc sql;
      create table one&code(drop = usubjid1 usubjid2) as
      select coalesce(aework.usubjid1, dom&code..usubjid2)as usubjid, aework.*, dom&code..* 
      from aework(rename=(usubjid= usubjid1)) left join dom&code(rename=(usubjid= usubjid2 stdy = ftdy ))
      on aework.usubjid1 = dom&code..usubjid2 order by usubjid, aeseq, &domain.dt, &&FVar&code;
   quit;

      *** Prior Findings;
   %if %scan(%upcase(&&FType&code),1," ") = PRIOR or %scan(%upcase(&&FType&code),1," ") = BOTH %then %do; 
      *** Get all records on or prior date;
      data pre&code;
         set one&code(where = (. < &domain.dt <= aestdt and base = 0));
      run;

      *** Get last Findings date for each AE;
      data &code.predate(keep = usubjid aeseq &domain.dt);
         set pre&code;
         by usubjid aeseq &domain.dt;
         if last.aeseq;
      run;

      *** Get all Findings on this last Findings date for each AE;
      data pre&code;
         merge &code.predate(in = ina) pre&code;
         by usubjid aeseq &domain.dt;
         if ina;
      run;

      data pre&code(keep = usubjid aeseq pretext&code ftdy &domain.dt rename = (ftdy = prestdy&code &domain.dt = predt&code));
         length pretext&code $ 2000;
         set pre&code;
         retain pretext&code;
         by usubjid aeseq;    
         if first.aeseq and &domain.term ne "" then pretext&code = &domain.term;
         else if first.aeseq and &domain.term = "" then pretext&code = "";
         else if &domain.term ne "" then pretext&code = catx("~", pretext&code, &domain.term);
         if last.aeseq;
      run;
      %SHRINKCHARS(dsn = pre&code, vars = pretext&code);
   %end;
   *** Subsequent Findings;   
   %if %scan(%upcase(&&FType&code),1," ") = SUBSEQUENT or %scan(%upcase(&&FType&code),1," ") = BOTH %then %do; 
      *** Get all records after date;
      data post&code;
         set one&code(where = (&domain.dt > aestdt and base = 0));
      run;

      *** Get first Findings date for each AE;
      data &code.postdate(keep = usubjid aeseq &domain.dt);
         set post&code;
         by usubjid aeseq &domain.dt;
         if first.aeseq;
      run;

      *** Get all Findings on this first Findings date for each AE;
      data post&code;
         merge &code.postdate(in = ina) post&code;
         by usubjid aeseq &domain.dt;
         if ina;
      run;

      data post&code(keep = usubjid aeseq posttext&code ftdy &domain.dt rename = (ftdy = poststdy&code &domain.dt = postdt&code));
         length posttext&code $ 2000;
         set post&code;
         retain posttext&code;
         by usubjid aeseq;
         if first.aeseq and &domain.term ne "" then posttext&code = &domain.term;
         else if first.aeseq and &domain.term = "" then posttext&code = "";
         else if &domain.term ne "" then posttext&code = catx("~", posttext&code, &domain.term);
         if last.aeseq;
      run;
      %SHRINKCHARS(dsn = post&code, vars = posttext&code);
   %end;
   *** Baseline Findings;
   %if %upcase(&&FBase&code) = YES %then %do;
      %if &domain = LB %then %do;   
         proc sql;
            create table base&code(drop = usubjid1 usubjid2) as
            select coalesce(aework.usubjid1, bdom&code..usubjid2) as usubjid, aework.*, bdom&code..* 
            from aework(rename=(usubjid= usubjid1)) left join bdom&code(rename=(usubjid= usubjid2)) 
            on aework.usubjid1 = bdom&code..usubjid2 order by usubjid, aeseq, &domain.dt, &&FVar&code;
         quit;

         data base&code;
            length &domain.term $ 2000;
            set base&code;
            if upcase(&domain.nrind) ne "%upcase(&trNormal)";

            %if &&FVar&code = &domain.TEST %then %let valuecode = %str(lowcase(&&FVar&code));
            %else %if &&FVar&code = &domain.TESTCD %then %let valuecode = %str(upcase(&&FVar&code));

            %if %scan(%upcase(&&StOr&code), 1, " ") = ORIGINAL %then %do;                                    
                %if ^%sysfunc(findw(%upcase( &&&domain.VARS), &domain.ORRESU)) %then %do;
                  &domain.ORRESU = "";             
                %end;
                ORRESN = input(&domain.ORRES, ?? best32.);
                ORNRLON = input(&domain.ORNRLO, ?? best32.);
                ORNRHIN = input(&domain.ORNRHI, ?? best32.);
                %if %upcase(&&FRound&code) = YES %then %do;
                  if lengthn(scan(ORRESN,2,".")) > &&FDec&code then ORRESN = round(ORRESN, 0.1**&&FDec&code);
                  if lengthn(scan(ORNRLON,2,".")) > &&FDec&code then ORNRLON = round(ORNRLON, 0.1**&&FDec&code);
                  if lengthn(scan(ORNRHIN,2,".")) > &&FDec&code then ORNRHIN = round(ORNRHIN, 0.1**&&FDec&code);
                %end;

               if ORRESN > . and ORNRLON > . and ORNRHIN > . then 
                     &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",ORRESN), cats(&domain.ORRESU,","), 
                     "%sysfunc(lowcase(&trRange)) =", cats("(",ORNRLON), "-", cats(ORNRHIN,")]"));    
               else if ORRESN > . and ORNRLON = . and ORNRHIN > . then 
                     &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",ORRESN), cats(&domain.ORRESU,","), 
                     "%sysfunc(lowcase(&trRange)) =", "(&trNA", "-", cats(ORNRHIN,")]"));    
               else if ORRESN > . and ORNRLON > . and ORNRHIN = . then 
                     &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",ORRESN), cats(&domain.ORRESU,","), 
                     "%sysfunc(lowcase(&trRange)) =", cats("(",ORNRLON), "-", "&trNA)]");    
               else if ORRESN > . and ORNRLON = . and ORNRHIN = . then 
                     &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",ORRESN), cats(&domain.ORRESU,"]"));
               else if ORRESN = . and &domain.ORRES ne "" then
                     &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",lowcase(&domain.ORRES)), cats(&domain.ORRESU,"]"));
            %end;
            %else %do;
                %if ^%sysfunc(findw(%upcase( &&&domain.VARS), &domain.STRESU)) %then %do;
                  &domain.STRESU = "";             
                %end;
                %if ^%sysfunc(findw(%upcase( &&&domain.VARS), &domain.STNRC)) %then %do;
                  &domain.STNRC = "";             
                %end;
                %if %upcase(&&FRound&code) = YES %then %do;
                  if lengthn(scan(&domain.STRESN,2,".")) > &&FDec&code then &domain.STRESN = round(&domain.STRESN, 0.1**&&FDec&code);
                  if lengthn(scan(&domain.STNRLO,2,".")) > &&FDec&code then &domain.STNRLO = round(&domain.STNRLO, 0.1**&&FDec&code);
                  if lengthn(scan(&domain.STNRHI,2,".")) > &&FDec&code then &domain.STNRHI = round(&domain.STNRHI, 0.1**&&FDec&code);
                %end;

               if missing(&&FVar&code) then &domain.term = "";
               else if &domain.STRESN > . and &domain.STNRLO > . and &domain.STNRHI > . then 
                     &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",&domain.STRESN), cats(&domain.STRESU,","), 
                     "%sysfunc(lowcase(&trRange)) =", cats("(",&domain.STNRLO), "-", cats(&domain.STNRHI,")]"));    
               else if &domain.STRESN > . and &domain.STNRLO = . and &domain.STNRHI > . then 
                     &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",&domain.STRESN), cats(&domain.STRESU,","), 
                     "%sysfunc(lowcase(&trRange)) =", "(&trNA", "-", cats(&domain.STNRHI,")]"));    
               else if &domain.STRESN > . and &domain.STNRLO > . and &domain.STNRHI = . then 
                     &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",&domain.STRESN), cats(&domain.STRESU,","), 
                     "%sysfunc(lowcase(&trRange)) =", cats("(",&domain.STNRLO), "-", "&trNA)]");    
               else if &domain.STRESN > . and &domain.STNRLO = . and &domain.STNRHI = . then 
                     &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",&domain.STRESN), cats(&domain.STRESU,","));
               %if %sysfunc(findw(%upcase( &&&domain.VARS), &domain.STRESC)) %then %do;                  
                  else if &domain.STRESN = . and &domain.STRESC ne "" and &domain.STNRC = "" then
                        &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",lowcase(&domain.STRESC)), cats(&domain.STRESU,"]"));
                  else if &domain.STRESN = . and &domain.STRESC ne "" and &domain.STNRC ne "" then
                        &domain.term = catx(" ", lowcase(&domain.nrind), &valuecode, cats("[",lowcase(&domain.STRESC)), cats(&domain.STRESU,","),
                        "%sysfunc(lowcase(&trRange)) =",cats(&domain.STNRC,"]"));
               %end;
            %end;         
         run;                  
         %SHRINKCHARS(dsn = base&code, vars = &domain.term);
      %end;
      %else %do;            
         proc sql;
            create table base&code(drop = usubjid1 usubjid2) as
            select coalesce(aework.usubjid1, dom&code..usubjid2) as usubjid, aework.*, dom&code..* 
            from aework(rename=(usubjid= usubjid1)) left join dom&code(rename=(usubjid= usubjid2) drop = stdy where = (base = 1))
            on aework.usubjid1 = dom&code..usubjid2 order by usubjid, aeseq, &domain.dt, &&FVar&code;
         quit;                                 
      %end;
   
      data base&code(keep = usubjid aeseq basetext&code);
         length basetext&code $ 5000;
         set base&code;
         retain basetext&code count;
         by usubjid aeseq;
         if first.aeseq and &domain.term ne "" then basetext&code = &domain.term;
         else if first.aeseq and &domain.term = "" then basetext&code = "";
         else if &domain.term ne "" then basetext&code = catx("~", basetext&code, &domain.term);
         if last.aeseq;
      run;      
      %SHRINKCHARS(dsn = base&code, vars = basetext&code);
   %end;
   
   proc datasets nolist;
      delete dom&code bdom&code;
   quit; 
   %exit:;
%mend FINDING;

*************************************************************************************;
*************************************************************************************;
*************************************************************************************;

%macro PARSEFINDLIST(code = A);
   %if %length(&&FTestList&code) %then %do;
      %let i = 1;
      %do %while(%length(%scan(&&FTestList&code,&i,' ')));
         %let temp = %scan(&&FTestList&code,&i,' ');
         %if ^%length(&&FWhereList&code) %then %let FWhereList&code = %nrbquote("&temp");
         %else %let FWhereList&code = &&FWhereList&code,%nrbquote("&temp");
         %let i = %eval(&i+1);
      %end;
   %end;
  
   %if %length(&&FWhereList&code) %then %do;
      %let tempval = &&FFDom&code.U;     
      %if %length(&&FWhereStmt&code) %then %do;
         %let FWhereStmt&code = (&&FWhereStmt&code) and &tempval.TESTCD in (&&FWhereList&code);
      %end;
      %else %do;
         %let FWhereStmt&code = &tempval.TESTCD in (&&FWhereList&code);    
      %end;   
   %end;      
%mend PARSEFINDLIST;

*************************************************************************************;
*************************************************************************************;
*************************************************************************************;

%macro NARRBYLIST(domain = , code = A);
      %let suffix = CAT SCAT LOC METHOD POS SPEC;
      %let byvar_&domain = ;
      
      %let j = 1; 
      %do %while(%length(%scan(&suffix,&j,' ')));
         %let stemp = %scan(&suffix,&j,' ');
         %if %sysfunc(indexw(&&&domain.VARS, &domain&stemp, ' ')) %then %let byvar_&domain = &&&byvar_&domain &domain&stemp;         
         %let j = %eval(&j+1);
      %end;      
      
      %if %length(&&&byvar_&domain) %then %do;
         proc sort nodupkey data = dom&code out = temp(keep = &&&byvar_&domain &&FVar&code);
            by &&FVar&code &&&byvar_&domain;
         run;

         data temp;
            set temp;
            by &&FVar&code &&&byvar_&domain;
            if first.&&FVar&code ne 1 or last.&&FVar&code ne 1;
         run;         
         %NObsVars(temp);
         
         %if &nobs %then %do;         
            data temp;
               length text $ 500;
               set temp;               
            run;                     
         
            %let j = 1;
            %let bystring =;
            %do %while(%length(%scan(&&&byvar_&domain,&j,' ')));
               %let stemp = %scan(&&&byvar_&domain,&j,' ');
               %let bystring = &bystring &stemp;
               
               proc sort data = temp out = temp;
                  by &&FVar&code &bystring;
               run;

               data temp;
                  set temp;
                  by &&FVar&code &bystring;
                  %if &j = 1 %then %do;
                     if first.&stemp = 1 and last.&stemp = 1 and missing(text) then text = &stemp;
                  %end;
                  %else %do;
                     if first.&stemp = 1 and last.&stemp = 1 and missing(text) then text = catx(" ", text, &stemp);
                  %end;
               run;
               %SHRINKCHARS(dsn = temp, vars = text);
               %let j = %eval(&j+1);
            %end;      

            proc sort data = dom&code;
               by &&FVar&code &&&byvar_&domain;
            run;         
         
            data dom&code(rename = (newcode = &&FVar&code));
               length newcode $ 400;
               merge dom&code(in = ina) temp(in = inb);
               by &&FVar&code &&&byvar_&domain;
               if ina;
               if not inb then newcode = &&FVar&code;
               else do;
                  %if %scan(%upcase(&&FCode&code), 2, " ") = NAME %then %do;
                     newcode = catx(" ", &&FVar&code, cats("(",text,")"));
                  %end;
                  %else %do;
                     newcode = compress(cats(&&FVar&code, text));
                  %end;
               end;
               drop &&FVar&code;
            run;
            %SHRINKCHARS(dsn = dom&code, vars = &&FVar&code);
         %end;
                  
         proc datasets nolist;
            delete temp;
         quit;
      %end;
      
      proc sort data = dom&code;
         by usubjid &&FVar&code &domain.DTC;
      run;
%mend NARRBYLIST;

*************************************************************************************;
*************************************************************************************;
*************************************************************************************;