%macro MERGESUPP(mergesupp = 1, addstudy = 0);
   *options mprint mlogic symbolgen; 
	%global suppmergefail suppmergesuccess;
	%let suppmergefail = ;
	%let suppmergesuccess = ;

	%let domlist = DM CO SE SV &findingsdomains &eventsdomains &interventionsdomains;
	%let domlist = %sysfunc(compbl(&domlist));
	%let availdoms = ;
	%let i = 1;
	%do %while(%length(%scan(&domlist,&i,' ')));
	   %let temp = %scan(&domlist,&i,' ');    
	   %if %sysfunc(findw(%upcase(&domains), &temp)) %then %do;
	      %let availdoms = &availdoms &temp;  
	   %end;
	   %let i = %eval(&i+1);
	%end;

	%let i = 1;
	%let first = 0;
	%do %while(%length(%scan(&availdoms,&i,' '))); 
		%let temp = %scan(&availdoms,&i,' ');
		%let data = %scan(&&in_&temp, 2, ".");
		%let lib = %scan(&&in_&temp, 1, ".");
		%global origsupp_&temp; 
		%let origsupp_&temp = &&in_&temp;		

		*** Add Supplemental Qualifier Data ***;
		%if %upcase(&lib) = SDTM and %sysfunc(findw(&suppdomains, %upcase(SUPP&temp))) and &mergesupp = 1 %then %do;
			%let IDVAR =; 
			%let IDVARVAL =;
			%let IDVARTYPE =;
			%let _tid_ = %sysfunc(open(&lib..SUPP&temp));
			%if %sysfunc(varnum(&_tid_,IDVAR)) %then %let IDVAR = IDVAR;
			%if %sysfunc(varnum(&_tid_,IDVARVAL)) %then %let IDVARVAL = IDVARVAL;
			%let _tid_ = %sysfunc(close(&_tid_));
			
			%if %length(&IDVAR) %then %do;
				%if %nrbquote(%lowcase(%substr(%sysfunc(getoption(locale)),1,2))) eq %nrbquote(zh) %then %do;
					proc freq noprint data = sdtm.SUPP&temp(encoding=ANY);
						tables &IDVAR) / missing out = temp1(rename = (&IDVAR = valuec));
					run;
				%end;
				%else %do;
					proc freq noprint data = sdtm.SUPP&temp;
						tables &IDVAR / missing out = temp1(rename = (&IDVAR = valuec));
					run;
				%end;

				data _null_;
					set temp1;
					if missing(valuec) and round(percent) = 100 then do;
						call symput("IDVAR", "");
					end;
				run;
				
				proc datasets nolist;
				   delete temp1;
				quit;	
		  	%end;

			%if %length(&IDVARVAL) %then %do;
				%if %nrbquote(%lowcase(%substr(%sysfunc(getoption(locale)),1,2))) eq %nrbquote(zh) %then %do;
					proc freq noprint data = sdtm.SUPP&temp(encoding=ANY);
						tables &IDVARVAL) / missing out = temp2(rename = (&IDVARVAL = valuec));
					run;
				%end;
				%else %do;
					proc freq noprint data = sdtm.SUPP&temp;
						tables &IDVARVAL / missing out = temp2(rename = (&IDVARVAL = valuec));
					run;
				%end;

				data _null_;
					set temp2;
					if missing(valuec) and round(percent) = 100 then do;
						call symput("IDVARVAL", "");
					end;
				run;
				
				proc datasets nolist;
				   delete temp2;
				quit;
		  	%end;

			*** only if both variables are present or absent ***;
			%if (%length(&IDVAR) and %length(&IDVARVAL)) or (^%length(&IDVAR) and ^%length(&IDVARVAL)) %then %do;
				%let IDVARACTUAL =;
				%if %length(&IDVAR) %then %do;
					data _null_;
						set sdtm.supp&temp(obs=1 keep = IDVAR where = (IDVAR ne ""));
						if length(IDVAR) then call symput("IDVARACTUAL",IDVAR);
					run;
				%end;

				%if %length(&IDVARACTUAL) %then %do;
					%let _tid_ = %sysfunc(open(&lib..&temp));
					%let _vn_ = %sysfunc(varnum(&_tid_,&IDVARACTUAL));
					%let idvartype = %sysfunc(vartype(&_tid_,&_vn_)); 
					%let _tid_ = %sysfunc(close(&_tid_));  
				%end;

				*** divert errors on merge with supp info ***;
				%if ^&first %then %do; 
					proc printto log = "&OutPath.SUPPMerge.log" new;
					run;
				%end;
				%else %do;
					proc printto log = "&OutPath.SUPPMerge.log";
					run;				
				%end;
				*** Removes duplicate qnams based on STUDYID, DOMAIN, USUBJID, IDVAR, IDVARVAL;   
				proc sql noprint;
					create table supp&temp(rename = (rdomain = DOMAIN) where = (IDVAR = "&IDVARACTUAL")) as
						select *, FREQ(qnam) AS numqnam
						from sdtm.supp&temp
						%if (%length(&IDVAR) and %length(&IDVARVAL)) %then %do;
							group by studyid, rdomain, usubjid, idvar, idvarval, qnam
						%end;
						%else %do;
							group by studyid, rdomain, usubjid, qnam
						%end;
						having numqnam = 1
						%if (%length(&IDVAR) and %length(&IDVARVAL)) %then %do;
							order by studyid, rdomain, usubjid, idvar, idvarval, qnam;
						%end;
						%else %do;
							order by studyid, rdomain, usubjid, qnam;
						%end;
				quit;

				*** This works if IDVAR and IDVARVAL are NULL;
				%if (%length(&IDVAR) and %length(&IDVARVAL)) %then %do; 
					proc transpose data = supp&temp out = supp&temp(drop = _name_ _label_ idvar idvarval);
						by studyid domain usubjid idvar idvarval qnam;
						var idvarval;
						id idvar;
						copy qval qlabel;
					run;
				%end;

				proc transpose data = supp&temp out = supp&temp(drop = _name_ _label_);
					%if %length(&IDVARACTUAL) %then %do;
						by studyid domain usubjid &IDVARACTUAL;
					%end;
					%else %do;
						by studyid domain usubjid;
					%end;
					var qval;
					id qnam;
					idlabel qlabel;
				run;

				%if &idvartype = N %then %do;
					data supp&temp(rename = (N&IDVARACTUAL = &IDVARACTUAL));
						set supp&temp;
						N&IDVARACTUAL = &IDVARACTUAL + 0;
						drop &IDVARACTUAL;
					run;
				%end;

				proc sql noprint;
					create table &temp as
					select * from sdtm.&temp as aa left join supp&temp(drop = domain) as bb
					%if %length(&IDVARACTUAL) %then %do;
						on aa.studyid = bb.studyid and aa.usubjid = bb.usubjid and aa.&IDVARACTUAL = bb.&IDVARACTUAL
						order by %sysfunc(transtrn(&&&temp.keys, %str( ), %str(,)));
					%end;
					%else %do;
						on aa.studyid = bb.studyid and aa.usubjid = bb.usubjid
						order by %sysfunc(transtrn(&&&temp.keys, %str( ), %str(,)));
					%end; 
				quit;
				%if %eval(&syserr > 4) %then %do;
					%let suppmergefail = &suppmergefail &temp;
				%end;
				%else %do;
					%let suppmergesuccess = &suppmergesuccess &temp;
				%end;
				proc printto;
				run;
				%if %sysfunc(findw(%upcase(&suppmergefail), &temp)) %then %do;
					proc sql noprint;
						create table &temp as
							select * from &&in_&temp
							order by %sysfunc(transtrn(&&&temp.keys, %str( ), %str(,)));
					quit;	
				%end;
				%let first = 1;
			%end;
			%else %do;
				%let suppmergefail = &suppmergefail &temp;
				proc sql noprint;
					create table &temp as
						select * from &&in_&temp
						order by %sysfunc(transtrn(&&&temp.keys, %str( ), %str(,)));
				quit;	   
			%end;
		%end;
		%else %do;
			proc sql noprint;
				create table &temp as
					select * from &&in_&temp
					order by %sysfunc(transtrn(&&&temp.keys, %str( ), %str(,)));
			quit;	   
		%end;
      
      %if &addstudy = 0 %then %do;
			%let in_&temp = work.&temp;
			%put updated in_&temp = &&in_&temp;
		%end;
		%else %if &addstudy = 1 %then %do;
		   proc datasets nolist;
		      delete &temp;
		   quit;		
		%end;
		
		%let i = %eval(&i+1);
	%end;

   %if %length(&ADSLpresent) %then %do;	
		proc sql noprint;
			create table adsl as
				select * from &in_adsl
				order by %sysfunc(transtrn(&ADSLkeys, %str( ), %str(,)));
		quit;

      %if &addstudy = 0 %then %do;
			%let in_ADSL = work.ADSL;
			%put updated in_ADSL = &in_ADSL;		
		%end;
		%else %if &addstudy = 1 %then %do;
		   proc datasets nolist;
		      delete adsl;
		   quit;		
		%end;
	%end;
	
	%put NOTE: SUPP Merges Success: &suppmergesuccess;
	%put NOTE: SUPP Merges Failure: &suppmergefail;
	*options nomprint nomlogic nosymbolgen; *********************************************************************************;
%mend MERGESUPP;